# Record Class MResource

java.lang.Object
java.lang.Record
com.io7m.montarre.api.MResource

Record Components:
  `file` - The file
  `hash` - The hash
  `role` - The role
  `caption` - The resource caption

All Implemented Interfaces:
  `MManifestItemType`

public record MResource(MFileName file, MHash hash, MResourceRole role, Optional<MCaption> caption) extends Record implements MManifestItemType
A resource item.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MResource(MFileName file, MHash hash, MResourceRole role, Optional<MCaption> caption)`
  A resource item.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Optional<MCaption>`
  `caption()`
  Returns the value of the `caption` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `MFileName`
  `file()`
  Returns the value of the `file` record component.
  `MHash`
  `hash()`
  Returns the value of the `hash` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `MResourceRole`
  `role()`
  Returns the value of the `role` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### MResource

    public MResource(MFileName file, MHash hash, MResourceRole role, Optional<MCaption> caption)
    A resource item.
    Parameters:
      `file` - The file
      `hash` - The hash
      `role` - The role
      `caption` - The resource caption

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### file

    public MFileName file()
    Returns the value of the `file` record component.
    Specified by:
      `file` in interface `MManifestItemType`
    Returns:
      the value of the `file` record component

  - ### hash

    public MHash hash()
    Returns the value of the `hash` record component.
    Specified by:
      `hash` in interface `MManifestItemType`
    Returns:
      the value of the `hash` record component

  - ### role

    public MResourceRole role()
    Returns the value of the `role` record component.
    Returns:
      the value of the `role` record component

  - ### caption

    public Optional<MCaption> caption()
    Returns the value of the `caption` record component.
    Returns:
      the value of the `caption` record component